#include "parallel.h"
#include "interface.h"
main(argc, argv)
{
   char                    Marix_FileName[256];
   char                    Vector_FileName[256];
   ZIP_MAILER              *Mailer;

   int                      p;
   int                      q;
   int                      m;
   int                      n;

   static matrix_host_bin   Matrix;
   static vector_host_bin   Vector;

   long                     sec;
   long                     usec;
   int                      i;
   int                      NBUS;

   printf("cube host -- demo for parallel sparse LU solver\n");

   initialize_host(&Matrix, &Vector, Marix_FileName, Vector_FileName, &NBUS);

   /* Hosue keeping work */

   Mailer = Matrix.Mailer;

   g2_pq(Mailer, p, q);

   Matrix.M = NBUS * 2;
   set_distribution(Mailer, Matrix.Row_Dis_Type, CDISTRI_ROW,
                    &(Matrix.Row_Dis),
                    &(Matrix.Row_Distribution),
                    &(Matrix.Row_Inverse_Distribution),
                    &(Matrix.Row_Distribution_limit),
                    &(Matrix.Row_Distribution_init),
                    Matrix.P, p, Matrix.M, &m,
                    (int) Matrix.Row_Extra_param1,
                    (int) Matrix.Row_Extra_param2,
                    &(Matrix.Row_Extra));

   Matrix.N = NBUS * 2;
   set_distribution(Mailer, Matrix.Col_Dis_Type, CDISTRI_COLUMN,
                    &(Matrix.Col_Dis),
                    &(Matrix.Col_Distribution),
                    &(Matrix.Col_Inverse_Distribution),
                    &(Matrix.Col_Distribution_limit),
                    &(Matrix.Col_Distribution_init),
                    Matrix.Q, q, Matrix.N, &n,
                    (int) Matrix.Col_Extra_param1,
                    (int) Matrix.Col_Extra_param2,
                    &(Matrix.Col_Extra));

   Matrix.NBUS = NBUS;
   if ((Matrix.Row_major_LU = (element **) malloc(sizeof(element *) * NBUS))
       == NULL)
   {
      print("parallel_cube_host(): Out of memory!\n");
      exit(1);
   }

   if ((Matrix.Row_major_LU_element_Count = (int *) malloc(sizeof(int)
                                                           * NBUS)) == NULL)
   {
      print("parallel_cube_host(): Out of memory!\n");
      exit(1);
   }

   for (i = 0; i < NBUS; i++)
   {
      Matrix.Row_major_LU[i] = NULL;
      Matrix.Row_major_LU_element_Count[i] = 0;
   }

   print("Command = %d\n", *Command);
   transmit_command_host(Mailer, *Command);

   /* Command decodeing */
   switch (*Command)
   {
      case DO_LU:
         print("before pack_unfactorized_matrix()\n");
         pack_unfactorized_matrix(&Matrix, Matrix_FileName, NBUS);
         transmit_matrix_host(Mailer, &Matrix);
         clear_real_matrix_host(&Matrix);
         receive_matrix_host(Mailer, &Matrix);
         clear_complex_matrix_host(&Matrix);
         receive_timing_host(Mailer, &sec, &usec);
         print("after receive_timing_host()\n");
         print("Timing Data for LU factor: %ld sec %ld usec\n", sec, usec);
         break;

      case DO_SOLVE:
#if 0
         pack_factorized_matrix_host(&Matrix, RELEM, CELEM, STAIRS, KORNO,
                                     NODIA, INDEX, IBUSO, INODIA, NBUS);
         transmit_matrix_host(Mailer, &Matrix);
         clear_real_matrix_host(&Matrix);
#endif

         pack_col_vector_host(&Vector, Vector_FileName, NBUS);
         transmit_col_vector_host(Mailer, &Vector);
         clear_col_vector_host(&Vector);

         receive_row_vector_host(Mailer, &Vector);
         unpack_row_vector_host(&Vector, Solution_FileName, NBUS);
         clear_row_vector_host(&Vector);

         receive_timing_host(Mailer, &sec, &usec);
         print("Timing Data for forward and back solve: %ld sec %ld usec\n",
               sec, usec);
         break;

      case TERMINATE:
         zip_exit();
         system("freecube");
         break;

      default:
         print("parallel_cube_host_(): Unknow command\n");
         exit(1);
   }
}

